#
# Definition of all trackable objects
# Identifier corresponds to Trackable ID set in Tracking Tools
# Use this for tracking a human body.
#
rigid_bodies:
    '1':
        pose: calib_plane/pose
        pose2d: calib_plane/ground_pose
        child_frame_id: calib_plane/base_link
        parent_frame_id: world
optitrack_config:
        multicast_address: 224.0.0.1
        ### port used to send commands to the Optitrack server
        command_port: 1510
        ### port used to receive data from the Optitrack server
        data_port: 1511
        ### frameRate associated with the publication of Optitrack data
        frame_rate: 50
        ### whether this is a simulation or a real situation
        simulation: false
        ### Maximum residual value obtained from the calibration of the
        ### Optitrack system (in m).
        maximum_residual: 0.0005
        ### Whether only markers are streamed by the Optitrack server
        stream_markers_only: false
        ### Whether data streamed by the Optitrack server are issued from
        ### a record or not
        repeat: true
        ### XML file that will be used for scaling
        scale_file: /home/auctus/sensoring_ws/opensim_ws/src/optitrack_full/src/ospi2urdf/utilis_files/scaling/scaleTool.xml
        ### Json file that will be used for informations about the osim to URDF transformation
        data_file: /home/auctus/sensoring_ws/opensim_ws/src/optitrack_full/src/ospi2urdf/utilis_files/data.txt
        ### Path to the ros package containing the URDF files
        ros_package_path: /home/auctus/sensoring_ws/opensim_ws/src/human_control        
        ### Type of recording : trc, rosbag, none (default)
        type_record: "trc"
        ### Name of the .trc file to load (if type_record: "trc")

        ## 2023/03/09, 31 markers

        ## by us

        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session-2023-03-09/mocap-skin/computer/Take 2023-03-09 04.40.14 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session-2023-03-09/mocap-skin/CoR/Take 2023-03-09 04.22.02 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session-2023-03-09/mocap-skin/direct/Take 2023-03-09 04.28.34 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session-2023-03-09/mocap-skin/security/Take 2023-03-09 04.31.27 PM.trc"
        
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session-2023-03-09/mocap-suit/computer/Take 2023-03-09 03.44.32 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session-2023-03-09/mocap-suit/CoR/Take 2023-03-09 03.27.13 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session-2023-03-09/mocap-suit/direct/Take 2023-03-09 03.34.07 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session-2023-03-09/mocap-suit/security/Take 2023-03-09 03.37.40 PM.trc"
        

        # 2023/03/07, 31 markers

        ## by us

        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session-2023-03-07/Take 2023-03-07 06.49.18 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session-2023-03-07/Take 2023-03-07 06.49.18 PM_calib_frame_536.trc"        

        # 2021/09/17, 33 markers

        # KO
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-09-17/Take 2021-09-17 01.31.20 PM.trc"        
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-09-17/Take 2021-09-17 01.32.48 PM.trc"

        # OK 

        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-09-17/Take_2021-09-17_01.31.20_PM_labeled_calib_frame_501.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-09-17/Take 2021-09-17 01.32.02 PM_calib_frame_574.trc"

        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-09-17/Take 2021-09-17 01.32.02 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-09-17/Take 2021-09-17 01.30.07 PM.trc"

        # 2021/06/29

        # ok
        # # trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-06-29/Mocap Suit/Neutral Pose/Take 2021-06-29 12.08.07 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-06-29/Mocap Suit/Neutral Pose/Take 2021-06-29 02.37.14 PM.trc"
        # #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-06-29/Mocap Suit/Neutral Pose/Take 2021-06-29 01.41.49 PM.trc"

        # 2021/06/24, 25 markers

        #ok 
        # trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-06-24/MOCAP Suit/Neutral pose/Take 2021-06-24 10.02.52 AM.trc"
        # trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-06-24/MOCAP Suit/Neutral pose/Take 2021-06-24 10.21.41 AM.trc"

        # 2021/05/06
        
        # Not really good

        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-05-06/Skin contact/CoR calibration/Take 2021-05-06 04.02.58 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-05-06/Skin contact/CoR calibration/Take 2021-05-06 03.52.35 PM.trc"

        # Completely KO
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-05-06/Skin contact/CoR calibration/Take 2021-05-06 03.43.21 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-05-06/Skin contact/CoR calibration/Take 2021-05-06 03.49.17 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-05-06/Skin contact/CoR calibration/Take 2021-05-06 03.45.41 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-05-06/Skin contact/Normal movements/Take 2021-05-06 04.13.21 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-05-06/Skin contact/Normal movements/Take 2021-05-06 04.15.01 PM.trc"

        # Almost OK until the end
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-05-06/Skin contact/Normal movements/Take 2021-05-06 04.11.28 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-05-06/Skin contact/Normal movements/Take 2021-05-06 04.10.23 PM.trc"
        
        # OK
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-05-06/Skin contact/Normal movements/Take 2021-05-06 04.18.41 PM.trc"        
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-05-06/Skin contact/CoR calibration/Take 2021-05-06 03.49.17 PM.trc"        

        # 2021/04/29

        # Really OK 
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-04-29/MOCAP suit/Neutral Pose/Take 2021-04-29 04.22.25 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-04-29/MOCAP suit/Neutral Pose/Take 2021-04-29 04.25.08 PM.trc"

        # Not really good
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-04-29/MOCAP suit/Neutral Pose/Take 2021-04-29 04.19.22 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-04-29/Skin contact/CoR Estimation/Take 2021-04-29 05.00.54 PM.trc"
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-04-29/Skin contact/Neutral pose/Take 2021-04-29 05.28.58 PM.trc"

        # KO
        # good ex of bug
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-04-29/Skin contact/Neutral pose/Take 2021-04-29 05.30.04 PM.trc"
        # (bug type = same index, but not the same marker)
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-04-29/Skin contact/Neutral pose/Take 2021-04-29 05.28.00 PM.trc"

        # just totally ko
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-04-29/Skin contact/Neutral pose/Take 2021-04-29 05.29.27 PM.trc"

        # 2021/04/23
        
        # Not really good
        #trc_file: "/home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/Session 2021-04-23/Take 2021-04-23 05.13.54 PM.trc"
opensim_config:
    ### Q vector of the calibration pose specific to this model
    q_calib: 
        ### size of the Q vector
        size: 25
        ### values of elements of the Q vector. All non indicated
        ### values will be set to 0. 
        ### values could be set as double, or as M_PI_2 / M_PI_4 
        ### for convenience
        '13': M_PI_2
        '21': M_PI_2
    ### Path to the .osim model
    #osim_path: /home/auctus/sensoring_ws/opensim_ws/src/optitrack_full/src/ospi2urdf/models/two_arms_only/two_arms_only_marks.osim
    osim_path: /home/auctus/sensoring_ws/opensim_ws/src/ospi2urdf2/models/upper_body/20230309/full_upper_body_marks_mod.osim
    #osim_path: "/home/auctus/sensoring_ws/opensim_ws/src/ospi2urdf2/models/upper_body/scaled_by_app/final.osim"
    ### Path to the .vtp files of the .osim model
    geometry_path: /home/auctus/sensoring_ws/opensim_ws/Documents/Models/SimulationDataAndSetupFiles-4.0/Geometry
    ### Path to XML file that could be used for Inverse Kinematics
    setup_ik_path: /home/auctus/sensoring_ws/opensim_ws/Documents/MOTIVE_data/IK_setup/Setup_IK_two_arms_only_marks.xml
    ### Topic on which JointSet Values of the model will be published
    topic_q: /q_pub
    ### (Simulation only). Speed of the movements of the body parts of the model
    ### in the simulation. Expressed in rad/s or m/s.
    simu_speed: 0.5
    ### (Simulation only). Maximum number of markers that could be suppressed in a frame, in order to simulate
    ### the possible disapperarance of markers during the recordings.
    simu_dissapear: 2
    ### (Simulation only). Number of frames where the number of markers and their ID should be
    ### identical (no new dissapperaing)
    simu_same_frames: 20
    ### (Simulation only). Maximal amplitude of the noise in position (m).
    simu_noise: 0.0001
    ### (Simulation only). Debugging tool, for publishing informations about
    ### the simulation of Optitrack markers.
    simu_verbose: false
    ### (Reality only). Debugging tool, for publishing informations about 
    ### the reception of Optitrack markers.
    reception_verbose: false
    ### Debugging tool, for publishing informations about the association of Optitrack
    ### markers to Opensim Markers.
    association_verbose: false
    ### Debugging tool, informations about ICP procedure.
    icp_verbose: false
    ### Debugging tool, informations about the filtering steps for the association of Optitrack 
    ### markers to Opensim markers (ex : updating of tolerance value, determination of markers of the
    ### same body part through ICP).
    filtering_verbose: false
    ### Debugging tool, informations about the first guess of the position of the body part before the ICP
    ### procedure.
    guess_verbose: false
    ### (Simulation only) Debugging tool, informations about the different errors with the association of the Opensim /
    ### Optitrack markers, joints errors, ...
    error_verbose: false
    ### Debugging tool, informations about the calibration process for the first association between Opensim et Optitrack markers.
    calibration_verbose: false

markers_2_rigid_body: 
    rigid_body_markers: 
        # - "HL1"
        # - "HL2"
        # - "HL3"
        # - "HL4"
        - "Marker1"
        - "Marker2"
        - "Marker3"
        - "Marker4"
        - "Marker5"
    ### Set up the original frame that should be used for calibration (= the frame from which the referential of 
    ### the bodyframe will be determined.
    ### Could be set to -1 to determine this frame automatically = the first frame with all the
    ### markers of rigid_body_markers.
    calib_frame: -1        
    ### Set up the referential associated with the rigid Body by indicating which markers should be on
    ### each axis. As those markers might not all be perfectly orthogonal, a priority factor should also
    ### be given to indicate whether the proximity of the marker to the axis is important or not.
    ### Format : nameOfMarker: priority_index|axis
    ### Priority_index : from 3 (most important) to 1 (less important)
    ### Axis : 1: x-axis; 2: y-axis; 3: z-axis (expressed in XYZ referential).
    referential_markers:
        "Marker2": 33
        "Marker3": 21
        "Marker5": 12
    ### Set up the referential associated with the rigid Body by indicating the orientation that the rigid
    ### body should have after being expressed into its local referential (determined by PCA).
    ### Angles are around X,Y,Z axes (in XYZ referential)
    rigid_body_pose: 
        - 0.0
        - 0.0
        - 1.57078      
    #trc_labeled_file: "/home/auctus/Documents/MOTIVE_data/Session 2021-09-17/Take_2021-09-17_01.31.20_PM_labeled_calib_frame_501.trc"
    #trc_labeled_file: "/home/auctus/Documents/MOTIVE_data/Session 2021-09-17/Take 2021-09-17 01.32.02 PM_calib_frame_579.trc"
    # trc_labeled_file: "/home/auctus/Documents/MOTIVE_data/Session 2021-09-22/circle_hand_r.trc"    
    #trc_labeled_file: "/home/auctus/Documents/MOTIVE_data/Session 2021-09-22/updown_hand_r.trc"    
    
    #trc_labeled_file : "/home/auctus/Documents/MOTIVE_data/Session 2021-11-18/Take 2021-11-18 09.41.29 AM.trc"
    #trc_labeled_file : "/home/auctus/Documents/MOTIVE_data/Session 2021-11-18/Take 2021-11-18 09.39.24 AM.trc"
    trc_labeled_file : "/home/auctus/Documents/MOTIVE_data/Session 2022-04-26/Take 2022-04-26-d0-L-B.trc"
    
    #"/home/auctus/Documents/MOTIVE_data/Session 2021-11-18/Take 2021-11-18 09.42.36 AM.trc"
